# ShanghaiTech CS110 2019 Project 1.2

#==============================================================================
#                              Project 1-2 Part 3
#                              parsetools.s README
#==============================================================================
# You should implement hex_to_str() and parse_int(). If you want to change test 
# partition, make sure you have totally understood the test case before you 
# changing them.
#==============================================================================

.data
#-------------------------------------------------------
# Test Data - Feel free to add your own after this line
#-------------------------------------------------------
# Used in hex_to_str
hex_str1:   .asciiz "abcdef12\n"
hex_str2:   .asciiz "00034532\n"

# Used in parse_int
hex_str3:   .asciiz "abcdef12"
hex_str4:   .asciiz "00034532"
dec_str1:   .asciiz "12345983"
dec_str2:   .asciiz "00023420"
#-------------------------------------------------------
# Test Data - Feel free to add your own above this line
#-------------------------------------------------------

test_header_name:   .asciiz "Running test parsetools:\n"
test_hex_to_str_name:   .asciiz "Testing hex_to_str():\n"
test_parse_int_name: .asciiz "Testing parse_int():\n"

newline:   .asciiz "\n"

tc_actual_str:      .asciiz "actual:   "
tc_expected_str:    .asciiz "expected: "
tc_testpass_str:    .asciiz " ...test passes\n"
tc_testfail_str:    .asciiz " ...test FAILS\n"

readline_err_ecall:
    .asciiz "Error in readline: Could not read from file.\n"
readline_err_bufsize:
    .asciiz "Error in readline: Exceeded maximum buffer size.\n"

.globl main
.text   
#------------------------------------------------------------------------------
# function hex_to_str()
#------------------------------------------------------------------------------
# Writes a 32-bit number in hexadecimal format to a string buffer, followed by
# the newline character and the NUL-terminator. The output must contain 8 digits
# so if neccessary put leading 0s in the buffer. Therefore, you should always 
# be writing 10 characters (8 digits, 1 newline, 1 NUL-terminator).
#
# For example:
#  0xabcd1234 => "abcd1234\n\0"
#  0x134565FF => "134565ff\n\0"
#  0x38       => "00000038\n\0"
#
# Write hex letters using lowercase, not uppercase. Do not add the prefix '0x'.
#
# Hint: Consider each group of 4 bits at a time and look at an ASCII table. If 
# you code has more than a few branch statements, you are probably not doing
# things very efficiently.
# Attention: Its a bit different from dec_to_str, not just copy it.
#
# Arguments:
#  a1 = int to write
#  a2 = character buffer to write into
#
# Returns: none
#------------------------------------------------------------------------------
hex_to_str:
    ### YOUR CODE ###

#------------------------------------------------------------------------------
# function parse_int()
#------------------------------------------------------------------------------
# Parses the string as an unsigned integer. The only bases supported are 10 and
# 16. We will assume that the number is valid, and that overflow does not happen.
#
# Arguments: 
#  a1 = string containing a number
#  a2 = base (will be either 10 or 16)
#
# Returns: the number
#------------------------------------------------------------------------------
parse_int:
    ### YOUR CODE ###

#------------------------------------------------------------------------------
# function streq() - paste your implementation here
#------------------------------------------------------------------------------
# Arguments:
#  a1 = string 1
#  a2 = string 2
#
# Returns: 0 if string 1 and string 2 are equal, -1 if they are not equal
#------------------------------------------------------------------------------
streq:
    ### PASTE YOUR CODE IN string.s HERE ###

###############################################################################
#                 Sample test cases, BE CAREFUL to change them                       
###############################################################################    
#-------------------------------------------
# Prints a newline 
# CLOBBERS: a1 and a0
#-------------------------------------------    
print_newline:
    la a1, newline
    li a0, 4
    ecall
    jr ra

#-------------------------------------------
# Prints the string
#  a1 = label containing address of string
# CLOBBERS: a1 and a0
#-------------------------------------------
print_str:
    li a0, 4
    ecall
    jr ra

#-------------------------------------------
# Checks whether the actual result matches the expected result
# Treats arguments as signed ints
#  a1 = register containing actual result
#  a2 = expected value of register
# CLOBBERS: a2, a1, a0, and t0
#-------------------------------------------
check_int_equals:
    addi sp, sp, -4
    sw ra, 0(sp)

    mv t0, a1
    la a1, tc_actual_str
    jal print_str
    
    mv a1, t0
    li a0, 1
    ecall

    jal print_newline

    la a1, tc_expected_str
    jal print_str
    
    mv a1, a2
    li a0, 1
    ecall
    
    bne t0, a1, check_int_notequal
    jal print_newline
    la a1, tc_testpass_str
    jal print_str
    j check_int_end
check_int_notequal:
    jal print_newline
    la a1, tc_testfail_str
    jal print_str
check_int_end:    
    lw ra, 0(sp)
    addi sp, sp, 4
    jr ra

#-------------------------------------------
# Checks whether the actual result matches the expected result
# Arguments should be strings
#  a1 = register containing actual result
#  a2 = label to expected string
# CLOBBERS: a2, a1, a0, and t0
#-------------------------------------------
check_str_equals:
    addi sp, sp, -4
    sw ra, 0(sp)
    mv t0, a1

    la a1, tc_actual_str
    jal print_str

    mv a1, t0
    li a0, 4
    ecall

    jal print_newline

    la a1, tc_expected_str
    jal print_str

    mv a1, a2
    li a0, 4
    ecall

    jal print_newline

    mv a1, t0
    jal streq
    bne a0, zero, check_str_notequal
    la a1, tc_testpass_str
    jal print_str
    j check_str_end
check_str_notequal:
    la a1, tc_testfail_str
    jal print_str 
check_str_end:
    lw ra, 0(sp)
    addi sp, sp, 4
    jr ra

#-------------------------------------------
# Test driver
#-------------------------------------------
main:
    la a1, test_header_name
    jal print_str

    jal print_newline
    jal test_hex_to_str

    jal print_newline
    jal test_parse_int
    
    li a0, 10
    ecall
    
#-------------------------------------------
# Tests hex_to_str()
#-------------------------------------------
test_hex_to_str:
    addi sp, sp, -8
    sw s1, 4(sp)
    sw ra, 0(sp)
    la a1, test_hex_to_str_name
    jal print_str

    li a0, 9
    li a1, 10
    ecall
    mv s1, a0

    li a1, 2882400018
    mv a2, s1
    jal hex_to_str
    mv a1, s1
    la a2, hex_str1
    jal check_str_equals
    
    li a1, 214322
    mv a2, s1
    jal hex_to_str
    mv a1, s1
    la a2, hex_str2
    jal check_str_equals
    
    lw ra, 0(sp)
    lw s1, 4(sp)
    addi sp, sp, 8
    jr ra

#-------------------------------------------
# Tests parse_int()
#-------------------------------------------
test_parse_int:
    addi sp, sp, -4
    sw ra, 0(sp)

    la a1, test_parse_int_name
    jal print_str

    la a1, hex_str3
    li a2, 16
    jal parse_int
    mv a1, a0
    li a2, 0xabcdef12
    jal check_int_equals

    la a1, hex_str4
    li a2, 16
    jal parse_int
    mv a1, a0
    li a2, 0x00034532
    jal check_int_equals

    la a1, dec_str1
    li a2, 10
    jal parse_int
    mv a1, a0
    li a2, 12345983
    jal check_int_equals

    la a1, dec_str2
    li a2, 10
    jal parse_int
    mv a1, a0
    li a2, 00023420
    jal check_int_equals

    lw ra, 0(sp)
    addi sp, sp, 4
    jr ra