# ShanghaiTech CS110 2019 Project 1.2 

#==============================================================================
#                              Project 1-2 Part 1
#                               String README
#==============================================================================
# In this file you will be implementing some utilities for manipulating strings.
# The functions you need to implement are:
#  - strlen()
#  - strncpy()
#  - copy_of_str()
#  - streq()
#  - dec_to_str()
# Test partition also in this file, if you want to change test partition, 
# make sure you have totally understood the test case before you changing them.
#==============================================================================
.data
newline:    .asciiz "\n"
tab:        .asciiz "\t"

tc_actual_str:      .asciiz "actual:   "
tc_expected_str:    .asciiz "expected: "
tc_testpass_str:    .asciiz " ...test passes\n"
tc_testfail_str:    .asciiz " ...test FAILS\n"

#-------------------------------------------------------
# Test Data - Feel free to add your own after this line
#-------------------------------------------------------
test_str1:      .asciiz "a9bw enijn webb"
test_str2:      .asciiz "a9bw en"
test_str3:      .asciiz ""

test_num1:      .asciiz "4396"
test_num2:      .asciiz "77777777"
test_num3:      .asciiz "1011"
#-------------------------------------------------------
# Test Data - Feel free to add your own above this line
#-------------------------------------------------------

test_header_name:       .asciiz "Running string tests:\n"
test_strlen_name:       .asciiz "Testing strlen():\n"
test_strncpy_name:      .asciiz "Testing strncpy():\n"
test_copy_of_str_name:  .asciiz "Testing copy_of_str():\n"
test_dec_to_str_name:   .asciiz "Testing dec_to_str():\n"

# 20 byte buffer x 5 = 100 byte buffer
test_buffer:    .word 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF
                .word 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF
                .word 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF
                .word 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF
                .word 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF 0xFFFFFFFF

.globl main
.text
#------------------------------------------------------------------------------
# function streq(), a basic function of this project, implement first.
# And we haven't add any separate test cases of this, but nearly any other 
# test case will use this function, so make sure your implementation correct.
#------------------------------------------------------------------------------
# Arguments:
#  a1 = string 1
#  a2 = string 2
#
# Returns: 0 if string 1 and string 2 are equal, -1 if they are not equal
#------------------------------------------------------------------------------
streq:
    ### YOUR CODE ###

#------------------------------------------------------------------------------
# function strlen()
#------------------------------------------------------------------------------
# Arguments:
#  a1 = string input
#
# Returns: the length of the string
#------------------------------------------------------------------------------
strlen:
    ### YOUR CODE ###

#------------------------------------------------------------------------------
# function strncpy()
#------------------------------------------------------------------------------
# Arguments:
#  a1 = pointer to destination array
#  a2 = source string
#  a3 = number of characters to copy
#
# Returns: the destination array
#------------------------------------------------------------------------------
strncpy:
    ### YOUR CODE ###
    
#------------------------------------------------------------------------------
# function copy_of_str()
#------------------------------------------------------------------------------
# Creates a copy of a string. You will need to use sbrk (ecall 9) to allocate
# space for the string. See wiki for details. strlen() and strncpy() will be 
# helpful for this function. ATTENTION: Be careful of the allocation space.
# Taking a second thought on how large (strlen or strlen + 1) should we allocate.
#
# Arguments:
#   a1 = string to copy
#
# Returns: pointer to the copy of the string
#------------------------------------------------------------------------------
copy_of_str:
    ### YOUR CODE ###

#------------------------------------------------------------------------------
# function dec_to_str()
#------------------------------------------------------------------------------
# Convert a number to its unsigned decimal integer string representation, eg.
# 35 => "35", 1024 => "1024". 
#
# Arguments:
#  a1 = int to write
#  a2 = character buffer to write into
#
# Returns: the number of digits written
#------------------------------------------------------------------------------
dec_to_str:
    ### YOUR CODE ###

###############################################################################
#                 Sample test cases, BE CAREFUL to change them                       
###############################################################################
#==============================================================================
#                              string.s Test Cases
#==============================================================================
#-------------------------------------------
# Prints a newline 
# CLOBBERS: a1 and a0
#-------------------------------------------    
print_newline:
    la a1, newline
    li a0, 4
    ecall
    jr ra

#-------------------------------------------
# Prints the string
#  a1 = label containing address of string
# CLOBBERS: a1 and a0
#-------------------------------------------
print_str:
    li a0, 4
    ecall
    jr ra
    
#-------------------------------------------
# Checks whether the actual result matches the expected result
# Treats arguments as unsigned ints
#  a1 = register containing actual result
#  a2 = expected value of register
# CLOBBERS: a2, a1, a0, and t0
#-------------------------------------------
check_uint_equals:
    addi sp, sp, -4
    sw ra, 0(sp)
    mv t0, a1

    la a1, tc_actual_str
    jal print_str

    mv a1, t0
    li a0, 1
    ecall

    jal print_newline

    la a1, tc_expected_str
    jal print_str

    mv a1, a2
    li a0, 1
    ecall

    bne t0, a1, check_uint_notequal
    jal print_newline
    la a1, tc_testpass_str
    jal print_str
    j check_uint_end
check_uint_notequal:
    jal print_newline
    la a1, tc_testfail_str
    jal print_str 
check_uint_end:
    lw ra, 0(sp)
    addi sp, sp, 4
    jr ra
    

#-------------------------------------------
# Checks whether the actual result matches the expected result
# Arguments should be strings
#  a1 = register containing actual result
#  a2 = label to expected string
# CLOBBERS: a2, a1, a0, and t0
#-------------------------------------------
check_str_equals:
    addi sp, sp, -4
    sw ra, 0(sp)
    mv t0, a1

    la a1, tc_actual_str
    jal print_str

    mv a1, t0
    li a0, 4
    ecall

    jal print_newline

    la a1, tc_expected_str
    jal print_str

    mv a1, a2
    li a0, 4
    ecall

    jal print_newline

    mv a1, t0
    jal streq
    bne a0, zero, check_str_notequal
    la a1, tc_testpass_str
    jal print_str
    j check_str_end
check_str_notequal:
    la a1, tc_testfail_str
    jal print_str 
check_str_end:
    lw ra, 0(sp)
    addi sp, sp, 4
    jr ra

#-------------------------------------------
# Test driver
#-------------------------------------------
main:
    la a1, test_header_name
    jal print_str
    jal print_newline

    jal test_strlen
    jal print_newline
    
    jal test_strncpy
    jal print_newline
    
    jal test_copy_of_str
    jal print_newline

    jal test_dec_to_str
    
    li a0, 10
    ecall

#-------------------------------------------
# Tests strlen()
#-------------------------------------------
test_strlen:
    addi sp, sp, -4
    sw ra, 0(sp)
    la a1, test_strlen_name
    jal print_str 

    la a1, test_str1
    jal strlen
    mv a1, a0
    li a2, 15
    jal check_uint_equals
    
    la a1, test_str3
    jal strlen
    mv a1, a0
    li a2, 0
    jal check_uint_equals
    
    la a1, test_str2
    jal strlen
    mv a1, a0
    li a2, 7
    jal check_uint_equals
    
    lw ra, 0(sp)
    addi sp, sp, 4
    jr ra

#-------------------------------------------
# Tests strncpy()
#-------------------------------------------
test_strncpy:
    addi sp, sp, -4
    sw ra, 0(sp)
    la a1, test_strncpy_name
    jal print_str

    la a1, test_buffer
    la a2, test_str1
    li a3, 16       # note: len + 1
    jal strncpy

    mv a1, a0
    la a2, test_str1
    jal check_str_equals
    
    la a1, test_buffer
    la a2, test_str2
    li a3, 8        # note: len + 1
    jal strncpy

    mv a1, a0
    la a2, test_str2
    jal check_str_equals
    
    lw ra, 0(sp)
    addi sp, sp, 4
    jr ra

#-------------------------------------------
# Tests copy_of_str()
#-------------------------------------------
test_copy_of_str:
    addi sp, sp, -12
    sw s1, 8(sp)
    sw s2, 4(sp)
    sw ra, 0(sp)
    la a1, test_copy_of_str_name
    jal print_str

    la a1, test_str1
    jal copy_of_str
    mv s1, a0
    
    mv a1, s1
    la a2, test_str1
    jal check_str_equals
    
    la a1, test_str2
    jal copy_of_str
    mv s2, a0

    mv a1, s2
    la a2, test_str2
    jal check_str_equals
    
    lw s1, 8(sp)
    lw s2, 4(sp)
    lw ra, 0(sp)
    addi sp, sp, 12
    jr ra

#-------------------------------------------
# Tests dec_to_str()
#-------------------------------------------
test_dec_to_str:
    addi sp, sp, 4
    sw ra, 0(sp)

    la a1, test_dec_to_str_name
    jal print_str

    li a1, 4396
    la a2, test_buffer
    jal dec_to_str
    la a1, test_buffer
    la a2, test_num1
    jal check_str_equals

    li a1, 77777777
    la a2, test_buffer
    jal dec_to_str
    la a1, test_buffer
    la a2, test_num2
    jal check_str_equals

    li a1, 001011
    la a2, test_buffer
    jal dec_to_str
    la a1, test_buffer
    la a2, test_num3
    jal check_str_equals

    lw ra, 0(sp)
    addi sp, sp, -4
    jr ra